<?php

namespace Luticate\Auth\DataAccess;

use Luticate\Auth\DataAccess\Models\LuticateUsers;
use Luticate\Utils\LuDataAccess;
use Luticate\Auth\DataAccess\Models\LuticatePermissionsUsers;
use Luticate\Auth\DBO\LuticatePermissionsUsersDbo;

class LuticatePermissionsUsersDataAccess extends LuDataAccess {
    protected static function getModel()
    {
        return new LuticatePermissionsUsers();
    }

    public static function getModelByName($user_id, $permission_name)
    {
        return LuticatePermissionsUsers::where("name", "=", $permission_name)->where("user_id", "=", $user_id)->first();
    }

    public static function getAllByUser($user_id, $page = 0, $perPage = PHP_INT_MAX)
    {
        return self::getMultiple(array(array('user_id', '=', $user_id)), array(array("name", "ASC")), $page, $perPage);
    }

    public static function getByName($user_id, $permission_name)
    {
        $perm = self::getModelByName($user_id, $permission_name);
        if (is_null($perm)) {
            return null;
        }
        return $perm->toDbo();
    }

    public static function delete($user_id, $permission_name)
    {
        LuticateUsers::find($user_id)->permissions()->detach($permission_name);
    }
}